﻿--[[	Detailed Durability
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

local AddOn=select(2,...);

----------------------------------
--[[	Client Versioning	]]
----------------------------------
--[[	WOW_PROJECT_ID contains either of the following constants
	WOW_PROJECT_MAINLINE = 1		Modern WoW
	WOW_PROJECT_CLASSIC = 2			Classic Vanilla
	WOW_PROJECT_BURNING_CRUSADE_CLASSIC = 5	Classic Burning Crusade

	LE_EXPANSION_LEVEL_CURRENT contains either of the classic-only constants
	LE_EXPANSION_CLASSIC = 0
	LE_EXPANSION_BURNING_CRUSADE = 1
	LE_EXPANSION_NORTHREND = 2
--]]
AddOn.IsModernClient=(WOW_PROJECT_ID==WOW_PROJECT_MAINLINE);
AddOn.IsClassicClient=(WOW_PROJECT_ID~=WOW_PROJECT_MAINLINE);
AddOn.IsVanillaClient=(AddOn.IsClassicClient and LE_EXPANSION_LEVEL_CURRENT==LE_EXPANSION_CLASSIC);
AddOn.IsBCClient=(AddOn.IsClassicClient and LE_EXPANSION_LEVEL_CURRENT==LE_EXPANSION_BURNING_CRUSADE);
AddOn.IsWrathClient=(AddOn.IsClassicClient and LE_EXPANSION_LEVEL_CURRENT==LE_EXPANSION_NORTHREND);
--[[
AddOn.IsVanillaClient=(WOW_PROJECT_ID==WOW_PROJECT_CLASSIC);
AddOn.IsTBCClient=(WOW_PROJECT_ID==WOW_PROJECT_BURNING_CRUSADE_CLASSIC);
AddOn.InterfaceVersion=select(4,GetBuildInfo());
--]]

--------------------------
--[[	Core API	]]
--------------------------
function AddOn.GetPercentColor(percent) return math.max(math.min(2*(1-percent),1),0),math.max(math.min(2*percent,1),0),0; end

function AddOn.ModifyFont(obj,font,size,flags)
	local origfont,origsize,origflags=obj:GetFont();
	return obj:SetFont(font or origfont,size or origsize,flags or origflags);
end

function AddOn.HookDurabilityUpdate(func)
	if AddOn.IsClassicClient then
		hooksecurefunc("DurabilityFrame_SetAlerts",func);
	else
		hooksecurefunc(DurabilityFrame,"SetAlerts",func);
	end
end
